package idi.diplom.linda.db.implementation;


import idi.diplom.linda.db.interfaces.AlarmDAO;
import idi.diplom.linda.db.interfaces.DAOFactory;
import idi.diplom.linda.db.interfaces.MedPacketDAO;
import idi.diplom.linda.db.interfaces.NoteDAO;
import idi.diplom.linda.db.interfaces.PatientDAO;

import org.hibernate.Session;


public class HibernateDAOFactory extends DAOFactory {

    public AlarmDAO getAlarmDAO() {
        return (AlarmDAO)instantiateDAO(AlarmDAOHibernate.class);
    }

    public MedPacketDAO getMedPacketDAO() {
        return (MedPacketDAO)instantiateDAO(MedPacketDAOHibernate.class);
    }

    public NoteDAO getNoteDAO() {
        return (NoteDAO)instantiateDAO(NoteDAOHibernate.class);
    }

    public PatientDAO getPatientDAO() {
        return (PatientDAO)instantiateDAO(PatientDAOHibernate.class);
    }

    private GenericHibernateDAO instantiateDAO(Class daoClass) {
        try {
            GenericHibernateDAO dao = (GenericHibernateDAO)daoClass.newInstance();
            dao.setSession(getCurrentSession());
            return dao;
        } catch (Exception ex) {
            throw new RuntimeException("Can not instantiate DAO: " + daoClass, ex);
        }
    }

    // You could override this if you don't want HibernateUtil for lookup
    protected Session getCurrentSession() {
        return HibernateUtil.getSessionFactory().getCurrentSession();
    }

    // Inline concrete DAO implementations with no business-related data access methods.
    // If we use public static nested classes, we can centralize all of them in one source file.

//    public static class CommentDAOHibernate
//            extends GenericHibernateDAO<Comment, Long>
//            implements CommentDAO {}
//
//    public static class ShipmentDAOHibernate
//            extends GenericHibernateDAO<Shipment, Long>
//            implements ShipmentDAO {}

}