package idi.diplom.linda.db.implementation;

import idi.diplom.linda.db.interfaces.MedPacketDAO;
import idi.diplom.linda.model.MedPacket;
import idi.diplom.linda.model.Patient;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;


public class MedPacketDAOHibernate extends GenericHibernateDAO<MedPacket, Long> implements
		MedPacketDAO {

	@Override
	@SuppressWarnings("unchecked")
	public MedPacket findLast(Patient p) {
		Calendar c = Calendar.getInstance();
		c.setTimeInMillis(c.getTimeInMillis()-60000);
		//c.setTimeInMillis(c.getTimeInMillis()-6*1000);
		Date d = c.getTime();
		MedPacket mp = (MedPacket)getSession().createCriteria(MedPacket.class)
		.add(Restrictions.eq( "patient", p))
		.add(Restrictions.between("timestamp", d, Calendar.getInstance().getTime()))
		.addOrder(Order.desc("id"))
		.setMaxResults(1)
		.uniqueResult();
		return mp;
	}

	@Override
	@SuppressWarnings("unchecked")
	public List<MedPacket> getMedPacketsBetweenDate(Patient p, Date fromTime, Date toTime) {
		List<MedPacket> retList = getSession().createCriteria(MedPacket.class)
		.add(Restrictions.eq("patient", p))
		.add(Restrictions.between("timestamp", fromTime, toTime))
		.list();
		return retList;
	}



	

}
