package idi.diplom.linda.db.interfaces;

import idi.diplom.linda.model.MedPacket;
import idi.diplom.linda.model.Patient;

import java.util.Date;
import java.util.List;


public interface MedPacketDAO extends GenericDAO<MedPacket, Long> {
	/**
	 * Gets the last medpacket saved on specified patient
	 * @param patient to get last medpacket from
	 * @return
	 */
	public MedPacket findLast(Patient p);
	
	/**
	 * Gets all medpackets between specified dates on specified patient
	 * @param patient to get monitoring data from
	 * @param fromDate
	 * @param toTime
	 * @return a list of monitoring data
	 */
	public List<MedPacket> getMedPacketsBetweenDate(Patient p, Date fromDate, Date toTime);
}
