package idi.diplom.linda.exceptions;
/**
 * Exception thrown when an error occurs interacting with the database layer
 * 
 */
public class DatabaseException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String message;
	
	/**
	 * Empty constructor
	 */
	public DatabaseException() {
	}

	/**
	 * Constructor that sets the message
	 * @param message
	 */
	public DatabaseException(String message) {
		super(message);
		this.message=message;
	}

	/**
	 * Constructor that takes a throwable cause
	 * @param cause
	 */
	public DatabaseException(Throwable cause) {
		super(cause);
	}

	/**
	 * Constructor that takes both a message and a throwable cause
	 * @param message
	 * @param cause
	 */
	public DatabaseException(String message, Throwable cause) {
		super(message, cause);
		this.message=message;
	}

	/**
	 * Gets the message
	 * @return the message
	 */
	public String getMessage() {
		return message;
	}

	/**
	 * @param message the message to set
	 */
	public void setMessage(String message) {
		this.message = message;
	}

}

