package idi.diplom.linda.lifeshirt;

import idi.diplom.linda.exceptions.LifeShirtException;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;

import org.apache.log4j.Logger;

public class FileListener extends Thread {

	private Processer processer;
	protected Logger log = Logger.getLogger(getClass());
	
	public FileListener(Processer p) {
		this.processer = p;

	}
	
	/**
	 * Listens for modification to the text file containing new strings received from the LifeShirt
	 */
	public void run() {

		BufferedReader inputStream = null;
		PrintWriter outputStream = null;
		File file = null;
		Date lastRead = new Date();
		//Date lastRead = new Date(0); // 1. jan 1970
		
		boolean process = true;
		log.info("Starting file processing\nReading at 1HZ");
		while (process) {
			try {
				file = new File("c:\\avatar\\vivo_out.txt");
				String inputline;
				
				if (file.lastModified() > lastRead.getTime()){
					inputStream = new BufferedReader(new FileReader(file));
					inputline = inputStream.readLine();
					try{
						processer.processMedPacket(inputline);
					}
					catch(LifeShirtException e){
						log.error("Error processing inputline" + e);
					}
					lastRead = new Date(file.lastModified());					
				}
				else{
					log.info("No modification to file");
				}
				
				
				
			} catch (FileNotFoundException e) {
				log.error("File not found" + e);
				//e.printStackTrace();
			} catch (IOException e) {
				log.error("IO - error" + e);
				//e.printStackTrace();

			} finally {
				if (inputStream != null) {
					try {
						inputStream.close();
					} catch (Exception ex) {
						log.error("Error when closing" + ex);
					}
				}

			}

			try {
				Thread.sleep(750);
			} catch (Exception e) {
			}
		}

	}
}
