package idi.diplom.linda.model;

import java.util.Date;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;

import org.hibernate.annotations.CollectionOfElements;
import org.hibernate.annotations.IndexColumn;

@Entity
public class Alarm {
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;
	private int triggeredThreshold;
	private Date timestamp;
	//private String triggeredThreshold;
	//private Sensor_enum triggeredThreshold;
	private Date dismissTime;
	private String dismissNote;
	@ManyToOne
	private Patient patient;

	@ManyToMany(targetEntity = idi.diplom.linda.model.MedPacket.class, cascade = {
			CascadeType.PERSIST, CascadeType.MERGE })
	@JoinTable(name = "ALARM_MEDPACKET", joinColumns = @JoinColumn(name = "ALARM_ID"), inverseJoinColumns = @JoinColumn(name = "MEDPACKET_ID"))
	//@OrderBy("Id")*
	//TODO order by
	@IndexColumn(name="position")
	private MedPacket[] medPackets;
	public MedPacket[] getMedPackets() {
		return medPackets;
	}

	public void setMedPackets(MedPacket[] medPackets) {
		this.medPackets = medPackets;
	}

	public void addMedPacket(MedPacket mp){
		if(this.getMedPackets()==null){
			this.setMedPackets(new MedPacket[0]);
		}
		MedPacket[] existingArray = this.getMedPackets();
		int size = existingArray.length+1;
		MedPacket[] newArray = new MedPacket[size];
		for(int i=0; i<existingArray.length; i++){
			newArray[i] = existingArray[i];
		}
		newArray[newArray.length-1] = mp;
		this.setMedPackets(newArray);
	}/**
	private Collection<MedPacket> medPackets;

	public Collection<MedPacket> getMedPackets() {
		return medPackets;
	}

	public void setMedPackets(Collection<MedPacket> medPackets) {
		this.medPackets = medPackets;
	}

	public void addMedPacket(MedPacket mp){
		this.medPackets.add(mp);
	}*/

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Date getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}
/**
	public String getTriggeredThreshold() {
		return triggeredThreshold;
	}

	public void setTriggeredThreshold(String triggeredThreshold) {
		this.triggeredThreshold = triggeredThreshold;
	}*/

	public Date getDismissTime() {
		return dismissTime;
	}

	public void setDismissTime(Date dismissTime) {
		this.dismissTime = dismissTime;
	}

	public String getDismissNote() {
		return dismissNote;
	}

	public void setDismissNote(String dismissNote) {
		this.dismissNote = dismissNote;
	}

	public Patient getPatient() {
		return patient;
	}

	public void setPatient(Patient patient) {
		this.patient = patient;
	}
/**
	public Sensor_enum getTriggeredThreshold() {
		return triggeredThreshold;
	}

	public void setTriggeredThreshold(Sensor_enum triggeredThreshold) {
		this.triggeredThreshold = triggeredThreshold;
	}*/

	public int getTriggeredThreshold() {
		return triggeredThreshold;
	}

	public void setTriggeredThreshold(int triggeredThreshold) {
		this.triggeredThreshold = triggeredThreshold;
	}

	public String toString(){
		return "Patient: " + this.getPatient() + "TriggeredTreshold: " + this.getTriggeredThreshold() + "NofMedPackets: " + this.getMedPackets().length;
	}
}
