using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MobileApp.lifeshirt;

namespace MobileApp
{
    public partial class ChangeProfileForm : Form
    {
        private Patient patient;
        public ChangeProfileForm(Patient activePatient)
        {
            InitializeComponent();
            patient = activePatient;
            fillOut();
        }

        private void fillOut()
        {
            nameTextbox.Text = patient.name;
            ageTextbox.Text = patient.age.ToString();
            lifeshirtidTextbox.Text = patient.lifeshirtId.ToString();
            alarmintervalTextbox.Text = patient.alarmInterval.ToString();

            hrwarnlowTextbox.Text = patient.hrThresWarnLow.ToString();
            hrwarnhighTextbox.Text = patient.hrThresWarnHigh.ToString();
            hralarmlowTextbox.Text = patient.hrThresAlarmLow.ToString();
            hralarmhighTextbox.Text = patient.hrThresAlarmHigh.ToString();

            brwarnlowTextbox.Text = patient.brThresWarnLow.ToString();
            brwarnhighTextbox.Text = patient.brThresWarnHigh.ToString();
            bralarmlowTextbox.Text = patient.brThresAlarmLow.ToString();
            bralarmhighTextbox.Text = patient.brThresAlarmHigh.ToString();

            spo2warnTextbox.Text = patient.spo2ThresWarnLow.ToString();
            spo2alarmTextbox.Text = patient.spo2ThresAlarmLow.ToString();
        }

        private void fillIn()
        {
            patient.name = nameTextbox.Text;
            try
            {
                patient.age = Convert.ToInt32(ageTextbox.Text);
                patient.lifeshirtId = Convert.ToInt32(lifeshirtidTextbox.Text);
                patient.alarmInterval = Convert.ToInt32(alarmintervalTextbox.Text);

                patient.hrThresWarnLow = Convert.ToInt32(hrwarnlowTextbox.Text);
                patient.hrThresWarnHigh = Convert.ToInt32(hrwarnhighTextbox.Text);
                patient.hrThresAlarmLow = Convert.ToInt32(hralarmlowTextbox.Text);
                patient.hrThresAlarmHigh = Convert.ToInt32(hralarmhighTextbox.Text);

                patient.brThresWarnLow = Convert.ToInt32(brwarnlowTextbox.Text);
                patient.brThresWarnHigh = Convert.ToInt32(brwarnhighTextbox.Text);
                patient.brThresAlarmLow = Convert.ToInt32(bralarmlowTextbox.Text);
                patient.brThresAlarmHigh = Convert.ToInt32(bralarmhighTextbox.Text);

                patient.spo2ThresWarnLow = Convert.ToInt32(spo2warnTextbox.Text);
                patient.spo2ThresAlarmLow = Convert.ToInt32(spo2alarmTextbox.Text);
            }
            catch (Exception e)
            {
                throw;
            }
        }

        private void ChangeProfileForm_Load(object sender, EventArgs e)
        {

        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            if (errorLabel.Visible)
            {
                errorLabel.Visible = false;
                menuItem1.Enabled = true;
            }
            else
            {
                Close();
            }
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            try
            {
                this.fillIn();
                this.DialogResult = System.Windows.Forms.DialogResult.OK;
                Close();
            }
            catch (Exception ex)
            {
                fillOut();
                menuItem1.Enabled = false;
                errorLabel.Visible = true;
            }
        }

        public Patient Patient
        {
            get
            {
                return patient;
            }
        }

    }
}