using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Messaging;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using MobileApp.lifeshirt;
using MobileApp.Logic;

namespace MobileApp
{
    public partial class Form1 : Form
    {
        private WSLogic ws;
        private Patient activePatient;
        private MedPacket lastMedPacket;
        //private List<Alarm> activeAlarms;
        private int lastAlarmCount;
        private AlarmForm af;
        private int medPacketCount;
        
        public Form1()
        {
            InitializeComponent();
            ws = new WSLogic();
            changeProfile.Enabled = false;
            lastAlarmCount = 0;
            af = null;
            medPacketCount = 0;
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            //ensure that the phone does not vibrate or play
            if (af != null)
            {
                af.stopAlarms();
            }
            Application.Exit();
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            
        }
/**
        protected override void OnPaint(PaintEventArgs e)
        {
            // Create string to draw.
            // string drawString = "Hello World";

            // Create font and brush.
            Font drawFont = new Font("Arial", 10, FontStyle.Regular);
            SolidBrush drawBrush = new SolidBrush(Color.Black);
            // Create point for upper-left corner of drawing.
            float x = 10.0F;
            float y = 10.0F;

            // Draw string to screen.
            e.Graphics.DrawString(testString, drawFont, drawBrush, x, y);

            
        }*/
        private void startMonitoring()
        {
            activePatientLabel.Text = "Patient: " + activePatient.name;
            rangeLabelHR.Text = "(" + activePatient.hrThresWarnLow + "-" + activePatient.hrThresWarnHigh + ")";
            rangeLabelBR.Text = "(" + activePatient.brThresWarnLow + "-" + activePatient.brThresWarnHigh + ")";
            rangeLabelSPO2.Text = "(<" + activePatient.spo2ThresWarnLow + ")";

            changeProfile.Enabled = true;
            monitoringItem.Enabled = true;
            startItem.Enabled = false;
            stopItem.Enabled = true;
            monitoringLabel.ForeColor = Color.GreenYellow;
            monitoringLabel.Text = "Monitoring: on";
            setVisible(true);
            medPacketCount = 0;
            //start getting medpackets
            timer1.Enabled = true;
        }
        private void stopMonitoring()
        {
            monitoringItem.Enabled = true;
            startItem.Enabled = true;
            stopItem.Enabled = false;
            monitoringLabel.ForeColor = Color.Red;
            monitoringLabel.Text = "Monitoring: off";
            setVisible(false);
            medPacketCount = 0;
            //start getting medpackets
            timer1.Enabled = false;
        }
        private void showPacket()
        {
            hrLabel.Text = "Heart: " + lastMedPacket.hr.ToString();
            brLabel.Text = "Breath: " + lastMedPacket.br.ToString();
            spo2Label.Text = "Spo2: " + lastMedPacket.spo2.ToString();
            //int temp = Math.Round(lastMedPacket.temp);
            int temp = (int)lastMedPacket.temp;
            tempLabel.Text = "Temp: " + temp.ToString();
            motionLabel.Text = "Motion: " + lastMedPacket.motion.ToString();
            postureLabel.Text = "Posture: " + lastMedPacket.posture.ToString();
            //lastMedPacket.timestamp.Value.ToLocalTime();
            DateTime date = lastMedPacket.timestamp.Value.ToLocalTime();
            //DateTime date2 = date.AddHours(1);
            timestampLabel.Text = date.ToString();
            //timestampLabel.Text = lastMedPacket.timestamp.Value.ToLocalTime().ToString();
            //DateTime.Now.ToUniversalTime();
            rangeLabelHR.Text = "(" + activePatient.hrThresWarnLow + "-" + activePatient.hrThresWarnHigh + ")";
        }

        private void selectPatient_Click(object sender, EventArgs e)
        {
            //stopmonitoring()?
            timer1.Enabled = false;
            List<Patient> patientList = null;
            bool exceptiontest = false;
            progressLabel.Visible = true;
            progressLabel.Update();
            try
            {
                progressBar1.Visible = true;
                for (int i = 0; i < 50; i++)
                {
                    progressBar1.Value = i;

                } 
                patientList = ws.GetAllPatients();
                for (int j = 50; j < 100; j++)
                {
                    progressBar1.Value = j;
                }
            }
            catch (Exception ex)
            {
                stopMonitoring();
                progressBar1.Visible = false;
                progressBar1.Value = 0;
                progressLabel.Visible = false;
                MessageForm mf = new MessageForm("An error occurred when trying to get patients. Please try again.");
                mf.ShowDialog();
                exceptiontest = true;
            }

            progressLabel.Visible = false;
            progressBar1.Visible = false;
            progressBar1.Value = 0;
            
            if (patientList == null || patientList.Count == 0)
            {
                //no patients were retrieved
                if (!exceptiontest)
                {
                    MessageForm mf = new MessageForm("No patients exist yet. Patients can be created from PC client.",this);
                    mf.ShowDialog();
                }
                if (activePatient != null)
                {
                    //continue to get packets from earlier patient
                    //timer1.Enabled = true;
                    startMonitoring();
                }
            }
            else
            {

                SelectPatient form1 = new SelectPatient(patientList);
                //form1.setPatientList(patientList);
                form1.ShowDialog();
                if (form1.Dialog == DialogResult.OK)
                {
                    Patient oldPatient = activePatient;
                    activePatient = form1.Patient;
                    if (activePatient != null)
                    {
                        startMonitoring();
                    }
                    else if (oldPatient != null)
                    {
                        activePatient = oldPatient;
                        startMonitoring();
                    }
                    else
                    {
                        //no patient chosen yet
                        //do nothing
                        //monitoringLabel.ForeColor = Color.Red;
                        //monitoringLabel.Text = "Monitoring: off";
                        stopMonitoring();
                    }
                }
                else if (form1.Dialog == DialogResult.Yes)
                {
                    activePatient = form1.Patient;
                    if(activePatient!=null){
                        change();
                        startMonitoring();
                    }
                }
            }
        }

        private void setVisible(bool isVisible)
        {
            hrLabel.Visible = isVisible;
            brLabel.Visible = isVisible;
            spo2Label.Visible = isVisible;
            tempLabel.Visible = isVisible;
            motionLabel.Visible = isVisible;
            postureLabel.Visible = isVisible;
            timestampLabel.Visible = isVisible;

            rangeLabelHR.Visible = isVisible;
            rangeLabelBR.Visible = isVisible;
            rangeLabelSPO2.Visible = isVisible;
        }

        private void change()
        {
            ChangeProfileForm cf = new ChangeProfileForm(activePatient);
            if (cf.ShowDialog() == DialogResult.OK)
            {
                activePatient = cf.Patient;
                activePatientLabel.Text = "Patient: " + activePatient.name;
                try
                {
                    ws.storePatient(activePatient);
                }
                catch (Exception ex)
                {
                    MessageForm mf = new MessageForm("Unable to save changes to patient permanently. Please try again.", this);
                    mf.ShowDialog();
                }
            }
        }

        private void changeProfile_Click(object sender, EventArgs e)
        {
            bool enabled = false;
            if (timer1.Enabled)
            {
                enabled = true;
                timer1.Enabled = false;

            }
            change();
            if (enabled)
            {
                startMonitoring();
            }
        }
        public void enableTimer(bool enable)
        {
            timer1.Enabled = enable;
        }
        private void timer_tick(object sender, EventArgs e)
        {
            if (af == null)
            {
                try
                {
                    lastMedPacket = ws.GetLastMedPacket(activePatient);
                }
                catch (Exception ex)
                {
                    stopMonitoring();
                    MessageForm mf = new MessageForm("An error occurred when fetching monitoring data.");
                    mf.ShowDialog();
                    return;
                }
                if (lastMedPacket != null)
                {
                    showPacket();
                    medPacketCount = 0;
                }
                else
                {
                    //no medpacket available
                    medPacketCount++;
                    if (medPacketCount > 5)
                    {
                        stopMonitoring();
                        MessageForm mf = new MessageForm("No monitoring data from this patient for a long time. Connection might be lost. Are the shirt within range?");
                        mf.ShowDialog();
                        medPacketCount = 0;
                        //give message that connection to lifeshirt possibly is lost
                    }
                }
            }
            try
            {
                List<Alarm> activeAlarms = ws.GetActiveAlarms(activePatient);
                if (activeAlarms.Count > 0 && af == null)
                {
                    //there is a new alarm and no alarmform is present
                    af = new AlarmForm(this);
                    af.setAlarms(activeAlarms);
                    af.ShowDialog();
                }
                else if (activeAlarms.Count > 0)
                {
                    //already presenting alarmform
                    af.setAlarms(activeAlarms);
                }
                //else if (lastAlarmCount != activeAlarms.Count && activeAlarms.Count == 0 && af != null)
                else if (activeAlarms.Count == 0 && af != null)
                {
                    af.setFinished();
                    af = null;
                    MessageForm mf = new MessageForm("One or more alarms were dismissed by another client.", this);
                    mf.ShowDialog();
                    //dismissed alarm by other listener
                }
                //check if alarm is dismissed
                if (af != null && af.Dialog == DialogResult.OK)
                {
                    //alarm dismissed
                    List<Alarm> dismissedList = af.Alarms;
                    try
                    {
                        ws.dismissAlarms(dismissedList);
                    }
                    catch (Exception ex)
                    {
                        MessageForm mf = new MessageForm("Unable to save that the alarm(s) were dismissed.", this);
                        mf.ShowDialog();
                    }
                    af = null;
                }
                lastAlarmCount = activeAlarms.Count;
            }
            catch (Exception ex)
            {
                MessageForm mf = new MessageForm("Unable to fetch possible alarms. Connection to server might be lost.", this);
                mf.ShowDialog();
                //stopMonitoring();
            }

        }

        private void startItem_Click(object sender, EventArgs e)
        {
            /**timer1.Enabled = true;
            startItem.Enabled = false;
            stopItem.Enabled = true;
            monitoringLabel.ForeColor = Color.GreenYellow;
            monitoringLabel.Text = "Monitoring: on";*/
            startMonitoring();
        }

        private void stopItem_Click(object sender, EventArgs e)
        {
            /**timer1.Enabled = false;
            startItem.Enabled = true;
            stopItem.Enabled = false;
            monitoringLabel.ForeColor = Color.Red;
            monitoringLabel.Text = "Monitoring: off";*/
            stopMonitoring();
        }

        
    }
}