using System;
using System.Collections.Generic;
using System.Text;

namespace MobileApp.Logic
{
    class AlarmType
    {
        public const int HR_WARN_LOW = 0;
        public const int HR_WARN_HIGH = 1;
        public const int HR_ALARM_LOW = 2;
        public const int HR_ALARM_HIGH = 3;
        public const int BR_WARN_LOW = 4;
        public const int BR_WARN_HIGH = 5;
        public const int BR_ALARM_LOW = 6;
        public const int BR_ALARM_HIGH = 7;
        public const int SPO2_WARN_LOW = 8;
        public const int SPO2_WARN_HIGH = 9;
        public const int SPO2_ALARM_LOW = 10;
        public const int SPO2_ALARM_HIGH = 11;

        public static bool isWarning(int alarmType)
        {
            if (alarmType == HR_WARN_HIGH || alarmType == HR_WARN_LOW ||
                alarmType == BR_WARN_HIGH || alarmType == BR_WARN_LOW ||
                alarmType == SPO2_WARN_HIGH || alarmType == SPO2_WARN_LOW)
                return true;
            else return false;
        }

        public static string GetString(int alarmType)
        {
            switch (alarmType)
            {
                case HR_WARN_LOW:
                    return "WARNING: low pulse";
                case HR_WARN_HIGH:
                    return "WARNING: high pulse";
                case HR_ALARM_LOW:
                    return "ALARM: low pulse";
                case HR_ALARM_HIGH:
                    return "ALARM: high pulse";
                case BR_WARN_LOW:
                    return "WARNING: low respiration";
                case BR_WARN_HIGH:
                    return "WARNING: high respiration";
                case BR_ALARM_LOW:
                    return "ALARM: low respiration";
                case BR_ALARM_HIGH:
                    return "ALARM: high respiration";
                case SPO2_WARN_LOW:
                    return "WARNING: low SPO2";
                case SPO2_WARN_HIGH:
                    return "WARNING: high SPO2";
                case SPO2_ALARM_LOW:
                    return "ALARM: low SPO2";
                case SPO2_ALARM_HIGH:
                    return "ALARM: high SPO2";
                default:
                    return "Alarm Type not specified";

            }


        }
    }
}
