using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Web.Services.Protocols;
using MobileApp.lifeshirt;

namespace MobileApp.Logic
{
    class WSLogic
    {
        private Random random;
        private LifeShirtWebServiceService ws;

        public WSLogic()
        {
            random = new Random();
            ws = new LifeShirtWebServiceService();
            ws.ConnectionGroupName = Guid.NewGuid().ToString();


        }
        /*
        public List<MedPacket> GetMedPackets(Patient p, DateTime from, DateTime to)
        {
            try
            {
                return new List<MedPacket>(ws.getPacketsBetweenDates(p, from, to));
            }
            catch (Exception ex)
            {
                throw;
            }

        }*/

        public List<Alarm> GetActiveAlarms(Patient p)
        {
            try
            {
                Alarm[] alarms = ws.getAllActiveAlarms(p);
                return new List<Alarm>(alarms);
            }
            catch (SoapException ex)
            {
                return null;
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        public MedPacket GetLastMedPacket(Patient p)
        {
            try
            {
                return ws.getLastMedPacket(p);
            }
            catch (SoapException ex)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        public List<Patient> GetAllPatients()
        {

            try
            {
                return new List<Patient>(ws.getAllPatients());

            }
            catch (Exception ex)
            {
                //Console.WriteLine(ex.StackTrace);
                throw;
                //return null;
            }
            /*List<Patient> l = new List<Patient>();

            string[] names = {"Ole Olsen", "Nina Hansen", "Petter Smart"};
            for(int i=0; i<3; i++)
            {
                Patient p = new Patient();
                p.AlarmInterval = 5;
                p.Name = names[i];
                p.Id = i;
                p.Age = 20 + i;
                p.BrThresAlarmHigh = 20;
                p.BrThresWarnHigh = 18;
                p.BrThresWarnLow = 10;
                p.BrThresAlarmLow = 8;

                p.HrThresAlarmHigh = 160;
                p.HrThresWarnHigh = 140;
                p.HrThresWarnLow = 70;
                p.HrThresWarnLow = 60;

                p.Spo2ThresAlarmHigh = 100;
                p.Spo2ThresWarnHigh = 99;
                p.Spo2ThresWarnLow = 90;
                p.Spo2ThresAlarmLow = 88;
                
                l.Add(p);
            }
            return l;*/

        }

        public void dismissAlarms(List<Alarm> alarms)
        {
            foreach (Alarm alarm in alarms)
            {
                try
                {
                    alarm.medPackets = new MedPacket[0];
                    ws.dismissAlarm(alarm);

                }
                catch (SoapException ex)
                {
                    //Console.WriteLine(ex.StackTrace);
                    throw;
                }
                catch (Exception ex)
                {
                    //Console.WriteLine(ex.StackTrace);
                    throw;
                }
            }
        }

        public void storeNote(Note note)
        {

            try
            {
                ws.saveNote(note);

            }
            catch (Exception e)
            {
                throw;
            }
        }

        public void storePatient(Patient p)
        {
            try
            {
                ws.updatePatient(p);
            }
            catch (Exception e)
            {
                throw;
            }
        }
    }
}
