using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace MobileApp
{
    public partial class MessageForm : Form
    {
        private Form1 mainForm;

        public MessageForm(String text, Form1 form)
        {
            InitializeComponent();
            messageLabel.Text = text;
            mainForm = form;
            enableTimer(false);
            PlaySound(MobileApp.Properties.Resources.ding, IntPtr.Zero, (int)(SND.ASYNC | SND.MEMORY));
        }

        public MessageForm(String text)
        {
            InitializeComponent();
            messageLabel.Text = text;
        }

        [DllImport("CoreDll.dll", EntryPoint = "PlaySound", SetLastError = true)]
        //private extern static int PlaySound(string szSound, IntPtr hMod, int flags);
        private extern static int PlaySound(byte[] szSound, IntPtr hMod, int flags);

        private enum SND
        {
            SYNC = 0x0000,
            ASYNC = 0x0001,
            NODEFAULT = 0x0002,
            MEMORY = 0x0004,
            LOOP = 0x0008,
            NOSTOP = 0x0010,
            NOWAIT = 0x00002000,
            ALIAS = 0x00010000,
            ALIAS_ID = 0x00110000,
            FILENAME = 0x00020000,
            RESOURCE = 0x00040004
        }

        private void enableTimer(bool start)
        {
            mainForm.enableTimer(start);
        }
        private void menuItem1_Click(object sender, EventArgs e)
        {
            if (mainForm != null)
            {
                enableTimer(true);
            }
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            Close();
        }
    }
}