using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MobileApp.Logic;
using MobileApp.lifeshirt;

namespace MobileApp
{
    public partial class SelectPatient : Form
    {
        private Patient patient;
        private List<Patient> pList;

        public SelectPatient(List<Patient> patientList)
        {
            InitializeComponent();
            pList = patientList;
            initialize();
            label1.Text = "LifeShirtId: ";
            label2.Text = "Age: ";
        }

        private void initialize()
        {
            if (pList != null)
            {
                patientListCombo.BeginUpdate();
                patientListCombo.DisplayMember = "name";
                try
                {
                    //pList = ws.GetAllPatients();
                    foreach (Patient p in pList)
                    {
                        patientListCombo.Items.Add(p);
                    }

                }
                catch (Exception ee)
                {
                }
                patientListCombo.EndUpdate();
            }
        }

        private void choosePatient_Click(object sender, EventArgs e)
        {
            patient = (Patient)patientListCombo.SelectedItem;
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            Close();
        }

        private void backToMain_Click(object sender, EventArgs e)
        {
            Close();
        }

        public Patient Patient
        {
            get
            {
                return patient;
            }
        }
        public DialogResult Dialog
        {
            get
            {
                return this.DialogResult;
            }
        }

        private void patientListCombo_SelectedIndexChanged(object sender, EventArgs e)
        {
            Patient patient2 = (Patient)patientListCombo.SelectedItem;
            if (patient2 != null)
            {
                label1.Text = "LifeShirtId: " + patient2.lifeshirtId;
                label2.Text = "Age: " + patient2.age;
                changeProfile.Enabled = true;
                choosePatient.Enabled = true;
            }
            else
            {
                choosePatient.Enabled = false;
            }
        }

        private void changeProfile_Click(object sender, EventArgs e)
        {
            patient = (Patient)patientListCombo.SelectedItem;
            this.DialogResult = System.Windows.Forms.DialogResult.Yes;
            Close();
        }

    }
}