using System;
using System.Collections.Generic;
using System.Net;
using System.Text;
//using DomainModel;
using System.Web.Services.Protocols;
using PcClient.lifeshirt;


namespace PcClient.BusinessLogic
{
    public class WSLogic
    {
        private Random random;
        private PcClient.LifeShirtWebServiceService ws;

        public WSLogic()
        {
            random = new Random();
            ws = new PcClient.LifeShirtWebServiceService();
            ws.ConnectionGroupName = Guid.NewGuid().ToString();
            
            
        }

        public List<MedPacket> GetMedPackets(Patient p, DateTime from, DateTime to, int resolution)
        {
            try
            {
                return new List<MedPacket>(ws.getPacketsBetweenDates(p, from, to, resolution) ); 
            }
            catch(Exception ex)
            {
                throw;
            }

        }


        public List<Note> GetAllNotes(Patient p)
        {
            try
            {
                return new List<Note>(ws.getAllNotes(p));
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        public List<Alarm> GetActiveAlarms(Patient p)
        {
            try
            {
                Alarm[] alarms = ws.getAllActiveAlarms(p);
                return new List<Alarm>(alarms);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return null;
            }
        }

        public MedPacket GetLastMedPacket(Patient p)
        {
              try {
                  return ws.getLastMedPacket(p);
              }
              catch(Exception ex)
              {
                  Console.WriteLine(ex.StackTrace);
                  return null;
              }
        }

        public List<Patient> GetAllPatients()  
        {            
            try
            {
                return new List<Patient>(ws.getAllPatients());
                
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.StackTrace);
                throw;               
            }
        }

        public void dismissAlarms(List<Alarm> alarms)
        {
            //TODO exception hndtering
            foreach (Alarm alarm in alarms)
            {
                try
                {
                    alarm.medPackets = new MedPacket[0];
                    ws.dismissAlarm(alarm);

                }
                catch (Exception ex)
                {
                    throw;
                }
            }
        }

        public void storeNote(Note note)
        {         
            try
            {
                ws.saveNote(note);
                
            }catch (Exception e)
            {
                throw;
            }
            
        }
        public void saveNewPatient(Patient p)
        {
            try
            {
                ws.saveNewPatient(p);
            }
            catch(Exception e)
            {
                throw;
            }
        }
        public void updatePatient(Patient p)
        {
            try
            {
                ws.updatePatient(p);
            }
            catch (Exception e)
            {
                throw;
            }
        }
    }
}