using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PcClient.BusinessLogic;
using PcClient.lifeshirt;

namespace PcClient
{
    public partial class EditPatientDialog : Form
    {
        private Patient patient;

        public EditPatientDialog(Patient p)
        {
            patient = p;
            
            InitializeComponent();

            if (patient == null)
                this.Name = "New Patient";
            else this.Name = "Edit Patient";

            fillInValues();
        }

        public Patient Patient
        {
            get { return patient; }
        }

        private void fillInValues()
        {
            if (patient == null)
            {
//Default values
                patient = new Patient();
                alarmIntervalTextBox.Text = 20.ToString();

                hrAlarmHigh.Text = 150.ToString();
                hrWarnHigh.Text = 135.ToString();
                hrWarnLow.Text = 60.ToString();
                hrAlarmLow.Text = 50.ToString();

                brAlarmHigh.Text = 35.ToString();
                brWarnHigh.Text = 26.ToString();
                brWarnLow.Text = 15.ToString();
                brAlarmLow.Text = 10.ToString();

                spo2WarnLow.Text = 93.ToString();
                spo2AlarmLow.Text = 88.ToString();
            }
            else
            {
                nameTextBox.Text = patient.name;
                ageTextBox.Text = patient.age.ToString();
                alarmIntervalTextBox.Text = patient.alarmInterval.ToString();

                hrAlarmHigh.Text = patient.hrThresAlarmHigh.ToString();
                hrWarnHigh.Text = patient.hrThresWarnHigh.ToString();
                hrWarnLow.Text = patient.hrThresWarnLow.ToString();
                hrAlarmLow.Text = patient.hrThresAlarmLow.ToString();

                brAlarmHigh.Text = patient.brThresAlarmHigh.ToString();
                brWarnHigh.Text = patient.brThresWarnHigh.ToString();
                brWarnLow.Text = patient.brThresWarnLow.ToString();
                brAlarmLow.Text = patient.brThresAlarmLow.ToString();

                spo2WarnLow.Text = patient.spo2ThresWarnLow.ToString();
                spo2AlarmLow.Text = patient.spo2ThresAlarmLow.ToString();

                lifeshirtidTextbox.Text = patient.lifeshirtId.ToString();
            }
        }

        private void updatePatient()
        {
            patient.name = nameTextBox.Text;
            patient.age = Convert.ToInt32(ageTextBox.Text);
            patient.alarmInterval = Convert.ToInt32(alarmIntervalTextBox.Text);

            patient.hrThresAlarmHigh = Convert.ToInt32(hrAlarmHigh.Text);
            patient.hrThresWarnHigh = Convert.ToInt32(hrWarnHigh.Text);
            patient.hrThresWarnLow = Convert.ToInt32(hrWarnLow.Text);
            patient.hrThresAlarmLow = Convert.ToInt32(hrAlarmLow.Text);

            patient.brThresAlarmHigh = Convert.ToInt32(brAlarmHigh.Text);
            patient.brThresWarnHigh = Convert.ToInt32(brWarnHigh.Text);
            patient.brThresWarnLow = Convert.ToInt32(brWarnLow.Text);
            patient.brThresAlarmLow = Convert.ToInt32(brAlarmLow.Text);

            patient.spo2ThresWarnLow = Convert.ToInt32(spo2WarnLow.Text);
            patient.spo2ThresAlarmLow = Convert.ToInt32(spo2AlarmLow.Text);

            patient.lifeshirtId = Convert.ToInt32(lifeshirtidTextbox.Text);
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            try
            {
                updatePatient();
                WSLogic wslogic = new WSLogic();
                wslogic.updatePatient(patient);   
                DialogResult = System.Windows.Forms.DialogResult.OK;
                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}