using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PcClient.BusinessLogic;
using PcClient.lifeshirt;

namespace PcClient
{
    public partial class NoteDialog : Form
    {
        private string noteText;
        private Patient activePatient;

        public NoteDialog(Patient p)
        {
            activePatient = p;
            InitializeComponent();
        }

        public string NoteText
        {
            get { return noteText; }
            set { noteText = value; }
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            try
            {
                noteText = textBox1.Text;

                WSLogic wsLogic = new WSLogic();
                Note note = new Note();
                note.created = DateTime.Now;
                note.createdLocally = true;
                note.patient = activePatient;
                note.note = noteText;
                wsLogic.storeNote(note);

                DialogResult = System.Windows.Forms.DialogResult.OK;
                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show("An error occurred: " + ex.Message);
                
            }
        }
    }
}